#include "simple_list.h"

bool simple_list::empty()
{
    if(headptr == NULL) {
        return true;
    } else {
        return false;
    }
}
void simple_list::push_front(int n)
{
    simple_list* temp = new simple_list();

    temp->link = headptr;
    headptr = temp;
    temp->n = n;
}

void simple_list::print()
{
    simple_list* temp;
    temp = headptr;
    while(temp != NULL) {
        cout << temp->n << " ";
        temp = temp->link;
    }
}

simple_list* simple_list::begin()
{
    if(headptr == NULL)
        return NULL;
    else
        return headptr;
}

simple_list* simple_list::end()
{
    if(headptr == NULL) {
        return NULL;
    }
    simple_list* temp = headptr;
    while(temp->link != NULL) {
        temp = temp->link;
    }
    return temp;
}

int simple_list::front() { return headptr->n; }

void simple_list::erase_after(simple_list* it)
{
    if(it->link == NULL) {
        cout << "\ninteger is not there to erase";
        return;
    }

    simple_list* temp = it;
    simple_list* temp1 = temp->link;
    temp->link = temp1->link;
}

void simple_list::insert_after(simple_list* it, int element)
{

    simple_list* temp = new simple_list();

    temp->n = element;

    temp->link = it->link;
    it->link = temp;
}

void simple_list::insert_after_position(int position, int element)
{
    int count = 0;
    simple_list* temp = new simple_list();
    if(count == position) {
        temp->link = headptr;
        headptr = temp;
        temp->n = element;
        return;
    }

    simple_list* temp1 = headptr;

    while(temp1 != NULL) {
        count++;
        if(count == position) {
            temp->link = temp1->link;
            temp1->link = temp;
            temp->n = element;
        }
        temp1 = temp1->link;
    }

    if(position > count)
        cout << "position out of range " << endl;
}

int simple_list::max_size()
{
    int count = 0;
    simple_list* temp;
    temp = headptr;
    while(temp != NULL) {
        count++;
        temp = temp->link;
    }
    return count;
}

int main()
{
    simple_list list;

    cout << boolalpha;
    cout << "Initially, empty(): " << list.empty() << endl;
    cout << "Before adding begin : " << list.begin() << endl;
    cout << "Before adding end :" << list.end() << endl;
    cout << "max_size ::" << list.max_size() << endl;
    list.push_front(20);
    list.push_front(30);
    list.push_front(40);

    cout << "After adding elements ,empty(): " << list.empty() << endl;
    list.print();
    cout << "\nmax_size ::" << list.max_size();

    if(!list.empty())
        cout << "\nThe first integer is " << list.front();

    //    simple_list *temp= begin(headptr);
    //    cout<<" first element "<<temp->n<<endl;

    simple_list* it = list.begin();
    it = it->link;
    list.erase_after(it);

    cout << "\nAfter erase ";
    list.print();
    cout << "\nmax_size ::" << list.max_size();

    simple_list* it1 = list.begin();

    list.insert_after(it1, 10);
    cout << "\nAfter insert " << endl;
    list.print();
    int position;
    cout << "\nenter the position : ";
    cin >> position;

    list.insert_after_position(position, 50);
    cout << "insert After position :" << position << endl;
    list.print();
    cout << "\nmax_size ::" << list.max_size();

    return 0;
}
